searchData={"items":[{"type":"module","title":"AuthManager","doc":"AuthManager es una librería completa para gestión de usuarios, roles y permisos\nen aplicaciones Phoenix, con soporte para herencia de roles y permisos.\n\nProporciona:\n- Gestión de usuarios con datos personales\n- Sistema jerárquico de roles y permisos\n- Verificación y autorización mediante middleware\n- Herramientas utilitarias para varias operaciones comunes","ref":"AuthManager.html"},{"type":"function","title":"AuthManager.assign_parent_permission/2","doc":"","ref":"AuthManager.html#assign_parent_permission/2"},{"type":"function","title":"AuthManager.assign_parent_role/2","doc":"","ref":"AuthManager.html#assign_parent_role/2"},{"type":"function","title":"AuthManager.assign_permission_to_role/2","doc":"","ref":"AuthManager.html#assign_permission_to_role/2"},{"type":"function","title":"AuthManager.assign_permission_to_user/2","doc":"","ref":"AuthManager.html#assign_permission_to_user/2"},{"type":"function","title":"AuthManager.assign_role_to_user/2","doc":"","ref":"AuthManager.html#assign_role_to_user/2"},{"type":"function","title":"AuthManager.can?/2","doc":"Verifica si un usuario tiene un permiso específico.","ref":"AuthManager.html#can?/2"},{"type":"function","title":"AuthManager.can_by?/1","doc":"Función unificada para verificar permisos o roles.\nEjemplo:\n```\nAuthManager.can_by?(user: user, permission: \"delete_users\")\nAuthManager.can_by?(user: user, role: \"admin\")\nAuthManager.can_by?(role: \"editor\", permission: \"edit_articles\")\n```","ref":"AuthManager.html#can_by?/1"},{"type":"function","title":"AuthManager.create_permission/1","doc":"","ref":"AuthManager.html#create_permission/1"},{"type":"function","title":"AuthManager.create_role/1","doc":"","ref":"AuthManager.html#create_role/1"},{"type":"function","title":"AuthManager.create_user/1","doc":"","ref":"AuthManager.html#create_user/1"},{"type":"function","title":"AuthManager.get_all_permissions/0","doc":"","ref":"AuthManager.html#get_all_permissions/0"},{"type":"function","title":"AuthManager.get_all_roles/0","doc":"","ref":"AuthManager.html#get_all_roles/0"},{"type":"function","title":"AuthManager.get_all_users/0","doc":"","ref":"AuthManager.html#get_all_users/0"},{"type":"function","title":"AuthManager.get_role_permissions/1","doc":"","ref":"AuthManager.html#get_role_permissions/1"},{"type":"function","title":"AuthManager.get_user_permissions/1","doc":"","ref":"AuthManager.html#get_user_permissions/1"},{"type":"function","title":"AuthManager.get_user_roles/1","doc":"","ref":"AuthManager.html#get_user_roles/1"},{"type":"function","title":"AuthManager.has_role?/2","doc":"Verifica si un usuario tiene un rol específico.","ref":"AuthManager.html#has_role?/2"},{"type":"function","title":"AuthManager.role_has_permission?/2","doc":"Verifica si un rol incluye un permiso específico.","ref":"AuthManager.html#role_has_permission?/2"},{"type":"module","title":"AuthManager.Accounts.AuthErrorHandler","doc":"Manejador de errores para problemas de autenticación.","ref":"AuthManager.Accounts.AuthErrorHandler.html"},{"type":"function","title":"AuthManager.Accounts.AuthErrorHandler.auth_error/3","doc":"Maneja errores de autenticación. Puede ser personalizado por la aplicación host.","ref":"AuthManager.Accounts.AuthErrorHandler.html#auth_error/3"},{"type":"module","title":"AuthManager.Accounts.AuthPipeline","doc":"Pipeline para la autenticación en aplicaciones Phoenix.","ref":"AuthManager.Accounts.AuthPipeline.html"},{"type":"function","title":"AuthManager.Accounts.AuthPipeline.call/2","doc":"","ref":"AuthManager.Accounts.AuthPipeline.html#call/2"},{"type":"function","title":"AuthManager.Accounts.AuthPipeline.init/1","doc":"","ref":"AuthManager.Accounts.AuthPipeline.html#init/1"},{"type":"module","title":"AuthManager.Accounts.AuthenticationPlug","doc":"Plug para autenticación de usuarios mediante JWT tokens.","ref":"AuthManager.Accounts.AuthenticationPlug.html"},{"type":"function","title":"AuthManager.Accounts.AuthenticationPlug.call/2","doc":"Verifica la autenticación del usuario mediante un token JWT.","ref":"AuthManager.Accounts.AuthenticationPlug.html#call/2"},{"type":"function","title":"Opciones - AuthManager.Accounts.AuthenticationPlug.call/2","doc":"* `:header` - El header HTTP donde se encuentra el token (default: \"authorization\")\n* `:schema` - El esquema de autenticación (default: \"Bearer\")\n* `:error_handler` - Módulo que maneja los errores de autenticación\n* `:halt_on_error` - Si debe detener la conexión en caso de error (default: true)","ref":"AuthManager.Accounts.AuthenticationPlug.html#call/2-opciones"},{"type":"function","title":"AuthManager.Accounts.AuthenticationPlug.init/1","doc":"Inicializa el plug con opciones personalizadas.","ref":"AuthManager.Accounts.AuthenticationPlug.html#init/1"},{"type":"module","title":"AuthManager.Accounts.Guardian","doc":"Implementación de Guardian para la autenticación basada en JWT.","ref":"AuthManager.Accounts.Guardian.html"},{"type":"function","title":"AuthManager.Accounts.Guardian.after_encode_and_sign/4","doc":"","ref":"AuthManager.Accounts.Guardian.html#after_encode_and_sign/4"},{"type":"function","title":"AuthManager.Accounts.Guardian.after_sign_in/5","doc":"","ref":"AuthManager.Accounts.Guardian.html#after_sign_in/5"},{"type":"function","title":"AuthManager.Accounts.Guardian.before_sign_out/3","doc":"","ref":"AuthManager.Accounts.Guardian.html#before_sign_out/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.build_claims/3","doc":"","ref":"AuthManager.Accounts.Guardian.html#build_claims/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.config/0","doc":"Fetches the configuration for this module.","ref":"AuthManager.Accounts.Guardian.html#config/0"},{"type":"function","title":"AuthManager.Accounts.Guardian.config/2","doc":"Returns a resolved value of the configuration found at a key.\n\nSee `Guardian.Config.resolve_value/1`.","ref":"AuthManager.Accounts.Guardian.html#config/2"},{"type":"function","title":"AuthManager.Accounts.Guardian.create_access_token/1","doc":"Función para crear tokens de acceso para un usuario.","ref":"AuthManager.Accounts.Guardian.html#create_access_token/1"},{"type":"function","title":"AuthManager.Accounts.Guardian.create_refresh_token/1","doc":"Función para crear tokens de refresco para un usuario.","ref":"AuthManager.Accounts.Guardian.html#create_refresh_token/1"},{"type":"function","title":"AuthManager.Accounts.Guardian.decode_and_verify/3","doc":"Decodes and verifies a token using the configuration on the implementation\nmodule.\n\nSee `Guardian.decode_and_verify/4`.","ref":"AuthManager.Accounts.Guardian.html#decode_and_verify/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.default_token_type/0","doc":"The default type of token for this module.","ref":"AuthManager.Accounts.Guardian.html#default_token_type/0"},{"type":"function","title":"AuthManager.Accounts.Guardian.encode_and_sign/3","doc":"Encodes the claims.\n\nSee `Guardian.encode_and_sign/4` for more information.","ref":"AuthManager.Accounts.Guardian.html#encode_and_sign/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.exchange/4","doc":"Exchanges a token of one type for another.\n\nSee `Guardian.exchange` for more information.","ref":"AuthManager.Accounts.Guardian.html#exchange/4"},{"type":"function","title":"AuthManager.Accounts.Guardian.exchange_refresh_token/1","doc":"Función para intercambiar un token de refresco por un nuevo token de acceso.","ref":"AuthManager.Accounts.Guardian.html#exchange_refresh_token/1"},{"type":"function","title":"AuthManager.Accounts.Guardian.get_user_from_token/1","doc":"Función para verificar y obtener el usuario a partir de un token.","ref":"AuthManager.Accounts.Guardian.html#get_user_from_token/1"},{"type":"function","title":"AuthManager.Accounts.Guardian.on_exchange/3","doc":"","ref":"AuthManager.Accounts.Guardian.html#on_exchange/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.on_refresh/3","doc":"","ref":"AuthManager.Accounts.Guardian.html#on_refresh/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.on_revoke/3","doc":"","ref":"AuthManager.Accounts.Guardian.html#on_revoke/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.on_verify/3","doc":"","ref":"AuthManager.Accounts.Guardian.html#on_verify/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.peek/1","doc":"Provides the content of the token but without verification\nof either the claims or the signature.\n\nClaims will be present at the `:claims` key.\n\nSee `Guardian.peek/2` for more information.","ref":"AuthManager.Accounts.Guardian.html#peek/1"},{"type":"function","title":"AuthManager.Accounts.Guardian.refresh/2","doc":"Refresh a token.\n\nSee `Guardian.refresh` for more information.","ref":"AuthManager.Accounts.Guardian.html#refresh/2"},{"type":"function","title":"AuthManager.Accounts.Guardian.resource_from_claims/1","doc":"Función utilizada para cargar el recurso a partir del subject.","ref":"AuthManager.Accounts.Guardian.html#resource_from_claims/1"},{"type":"function","title":"AuthManager.Accounts.Guardian.resource_from_token/3","doc":"Fetch the resource and claims directly from a token.\n\nSee `Guardian.resource_from_token` for more information.","ref":"AuthManager.Accounts.Guardian.html#resource_from_token/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.revoke/2","doc":"Revoke a token.\n\nSee `Guardian.revoke` for more information.","ref":"AuthManager.Accounts.Guardian.html#revoke/2"},{"type":"function","title":"AuthManager.Accounts.Guardian.sliding_cookie/3","doc":"If Guardian.Plug.SlidingCookie is used, this callback will be invoked to\nreturn the new claims, or an error (which will mean the cookie will not\nbe refreshed).","ref":"AuthManager.Accounts.Guardian.html#sliding_cookie/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.subject_for_token/2","doc":"Función utilizada para extraer el identificador del recurso de un subject.","ref":"AuthManager.Accounts.Guardian.html#subject_for_token/2"},{"type":"function","title":"AuthManager.Accounts.Guardian.verify_claims/2","doc":"","ref":"AuthManager.Accounts.Guardian.html#verify_claims/2"},{"type":"module","title":"AuthManager.Accounts.Guardian.Plug","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.authenticated?/2","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#authenticated?/2"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.clear_remember_me/2","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#clear_remember_me/2"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.current_claims/2","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#current_claims/2"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.current_resource/2","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#current_resource/2"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.current_token/2","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#current_token/2"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.implementation/0","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#implementation/0"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.put_current_claims/3","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#put_current_claims/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.put_current_resource/3","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#put_current_resource/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.put_current_token/3","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#put_current_token/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.put_session_token/3","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#put_session_token/3"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.remember_me/4","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#remember_me/4"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.remember_me_from_token/4","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#remember_me_from_token/4"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.sign_in/4","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#sign_in/4"},{"type":"function","title":"AuthManager.Accounts.Guardian.Plug.sign_out/2","doc":"","ref":"AuthManager.Accounts.Guardian.Plug.html#sign_out/2"},{"type":"module","title":"AuthManager.Accounts.Person","doc":"Esquema abstracto que define los campos comunes para datos personales.\nEste esquema será utilizado como un comportamiento que será implementado por User.","ref":"AuthManager.Accounts.Person.html"},{"type":"macro","title":"AuthManager.Accounts.Person.person_fields/0","doc":"","ref":"AuthManager.Accounts.Person.html#person_fields/0"},{"type":"macro","title":"AuthManager.Accounts.Person.person_validations/0","doc":"","ref":"AuthManager.Accounts.Person.html#person_validations/0"},{"type":"module","title":"AuthManager.Accounts.User","doc":"Esquema que representa a un usuario en el sistema.\nHereda los campos personales del esquema Person.","ref":"AuthManager.Accounts.User.html"},{"type":"function","title":"AuthManager.Accounts.User.create_changeset/2","doc":"Changeset para crear un nuevo usuario.","ref":"AuthManager.Accounts.User.html#create_changeset/2"},{"type":"function","title":"AuthManager.Accounts.User.full_name/1","doc":"","ref":"AuthManager.Accounts.User.html#full_name/1"},{"type":"function","title":"AuthManager.Accounts.User.login_changeset/1","doc":"Actualiza el timestamp de último inicio de sesión.","ref":"AuthManager.Accounts.User.html#login_changeset/1"},{"type":"function","title":"AuthManager.Accounts.User.password_changeset/2","doc":"Changeset para actualizar la contraseña de un usuario.","ref":"AuthManager.Accounts.User.html#password_changeset/2"},{"type":"function","title":"AuthManager.Accounts.User.person_changeset/2","doc":"","ref":"AuthManager.Accounts.User.html#person_changeset/2"},{"type":"function","title":"AuthManager.Accounts.User.update_changeset/2","doc":"Changeset para actualizar un usuario existente.","ref":"AuthManager.Accounts.User.html#update_changeset/2"},{"type":"module","title":"AuthManager.Accounts.UserService","doc":"Servicio para operaciones relacionadas con usuarios.","ref":"AuthManager.Accounts.UserService.html"},{"type":"function","title":"AuthManager.Accounts.UserService.activate/1","doc":"Activa un usuario.","ref":"AuthManager.Accounts.UserService.html#activate/1"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.activate/1","doc":"iex> UserService.activate(user)\n    {:ok, %User{}}","ref":"AuthManager.Accounts.UserService.html#activate/1-ejemplos"},{"type":"function","title":"AuthManager.Accounts.UserService.authenticate/2","doc":"Autentica a un usuario por nombre de usuario/email y contraseña.","ref":"AuthManager.Accounts.UserService.html#authenticate/2"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.authenticate/2","doc":"iex> UserService.authenticate(\"usuario\", \"contraseña\")\n    {:ok, %User{}}\n\n    iex> UserService.authenticate(\"usuario\", \"incorrecta\")\n    {:error, :invalid_credentials}","ref":"AuthManager.Accounts.UserService.html#authenticate/2-ejemplos"},{"type":"function","title":"AuthManager.Accounts.UserService.change_password/2","doc":"Cambia la contraseña de un usuario.","ref":"AuthManager.Accounts.UserService.html#change_password/2"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.change_password/2","doc":"iex> UserService.change_password(user, \"nueva_contraseña\")\n    {:ok, %User{}}","ref":"AuthManager.Accounts.UserService.html#change_password/2-ejemplos"},{"type":"function","title":"AuthManager.Accounts.UserService.count_users/1","doc":"Cuenta el número de usuarios según criterios de búsqueda.","ref":"AuthManager.Accounts.UserService.html#count_users/1"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.count_users/1","doc":"iex> UserService.count_users(search: \"juan\", active: true)\n    5","ref":"AuthManager.Accounts.UserService.html#count_users/1-ejemplos"},{"type":"function","title":"AuthManager.Accounts.UserService.get_by_email/1","doc":"Obtiene un usuario por su email.","ref":"AuthManager.Accounts.UserService.html#get_by_email/1"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.get_by_email/1","doc":"iex> UserService.get_by_email(\"juan@example.com\")\n    %User{}","ref":"AuthManager.Accounts.UserService.html#get_by_email/1-ejemplos"},{"type":"function","title":"AuthManager.Accounts.UserService.get_by_username/1","doc":"Obtiene un usuario por su nombre de usuario.","ref":"AuthManager.Accounts.UserService.html#get_by_username/1"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.get_by_username/1","doc":"iex> UserService.get_by_username(\"juanperez\")\n    %User{}","ref":"AuthManager.Accounts.UserService.html#get_by_username/1-ejemplos"},{"type":"function","title":"AuthManager.Accounts.UserService.get_user/1","doc":"Obtiene un usuario por su ID.","ref":"AuthManager.Accounts.UserService.html#get_user/1"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.get_user/1","doc":"iex> UserService.get_user(1)\n    %User{}\n\n    iex> UserService.get_user(999)\n    nil","ref":"AuthManager.Accounts.UserService.html#get_user/1-ejemplos"},{"type":"function","title":"AuthManager.Accounts.UserService.get_user!/1","doc":"Obtiene un usuario por su ID, lanzando un error si no existe.","ref":"AuthManager.Accounts.UserService.html#get_user!/1"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.get_user!/1","doc":"iex> UserService.get_user!(1)\n    %User{}\n\n    iex> UserService.get_user!(999)\n    ** (Ecto.NoResultsError)","ref":"AuthManager.Accounts.UserService.html#get_user!/1-ejemplos"},{"type":"function","title":"AuthManager.Accounts.UserService.inactivate/1","doc":"Inactiva un usuario.","ref":"AuthManager.Accounts.UserService.html#inactivate/1"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.inactivate/1","doc":"iex> UserService.inactivate(user)\n    {:ok, %User{}}","ref":"AuthManager.Accounts.UserService.html#inactivate/1-ejemplos"},{"type":"function","title":"AuthManager.Accounts.UserService.search_users/1","doc":"Busca usuarios según criterios.","ref":"AuthManager.Accounts.UserService.html#search_users/1"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.search_users/1","doc":"iex> UserService.search_users(search: \"juan\", active: true)\n    [%User{}, ...]","ref":"AuthManager.Accounts.UserService.html#search_users/1-ejemplos"},{"type":"function","title":"AuthManager.Accounts.UserService.update_user/2","doc":"Actualiza los datos de un usuario.","ref":"AuthManager.Accounts.UserService.html#update_user/2"},{"type":"function","title":"Ejemplos - AuthManager.Accounts.UserService.update_user/2","doc":"iex> UserService.update_user(user, %{first_name: \"Nuevo Nombre\"})\n    {:ok, %User{}}","ref":"AuthManager.Accounts.UserService.html#update_user/2-ejemplos"},{"type":"module","title":"AuthManager.Authorization.Permission","doc":"Esquema que representa un permiso en el sistema.\nLos permisos pueden tener padres, lo que permite herencia.","ref":"AuthManager.Authorization.Permission.html"},{"type":"function","title":"AuthManager.Authorization.Permission.changeset/2","doc":"Changeset para crear o actualizar un permiso.","ref":"AuthManager.Authorization.Permission.html#changeset/2"},{"type":"function","title":"AuthManager.Authorization.Permission.get_all_children/2","doc":"Obtiene todos los permisos hijos recursivamente.","ref":"AuthManager.Authorization.Permission.html#get_all_children/2"},{"type":"function","title":"AuthManager.Authorization.Permission.get_all_parents/2","doc":"Obtiene todos los permisos padre recursivamente.","ref":"AuthManager.Authorization.Permission.html#get_all_parents/2"},{"type":"module","title":"AuthManager.Authorization.Role","doc":"Esquema que representa un rol en el sistema.\nLos roles pueden tener padres, lo que permite herencia.","ref":"AuthManager.Authorization.Role.html"},{"type":"function","title":"AuthManager.Authorization.Role.changeset/2","doc":"Changeset para crear o actualizar un rol.","ref":"AuthManager.Authorization.Role.html#changeset/2"},{"type":"function","title":"AuthManager.Authorization.Role.get_all_child_roles/2","doc":"Obtiene todos los roles hijo recursivamente.","ref":"AuthManager.Authorization.Role.html#get_all_child_roles/2"},{"type":"function","title":"AuthManager.Authorization.Role.get_all_parent_roles/2","doc":"Obtiene todos los roles padre recursivamente.","ref":"AuthManager.Authorization.Role.html#get_all_parent_roles/2"},{"type":"module","title":"AuthManager.Authorization.RolePermission","doc":"Esquema intermedio para la relación muchos a muchos entre roles y permisos.","ref":"AuthManager.Authorization.RolePermission.html"},{"type":"function","title":"AuthManager.Authorization.RolePermission.changeset/2","doc":"Changeset para crear o actualizar una asignación de permiso a rol.","ref":"AuthManager.Authorization.RolePermission.html#changeset/2"},{"type":"module","title":"AuthManager.Authorization.RoleRole","doc":"Esquema intermedio para la relación de herencia entre roles (padres e hijos).","ref":"AuthManager.Authorization.RoleRole.html"},{"type":"function","title":"AuthManager.Authorization.RoleRole.changeset/2","doc":"Changeset para crear o actualizar una relación entre roles.","ref":"AuthManager.Authorization.RoleRole.html#changeset/2"},{"type":"module","title":"AuthManager.Authorization.UserPermission","doc":"Esquema intermedio para la relación muchos a muchos entre usuarios y permisos.","ref":"AuthManager.Authorization.UserPermission.html"},{"type":"function","title":"AuthManager.Authorization.UserPermission.changeset/2","doc":"Changeset para crear o actualizar una asignación de permiso a usuario.","ref":"AuthManager.Authorization.UserPermission.html#changeset/2"},{"type":"module","title":"AuthManager.Authorization.UserRole","doc":"Esquema intermedio para la relación muchos a muchos entre usuarios y roles.","ref":"AuthManager.Authorization.UserRole.html"},{"type":"function","title":"AuthManager.Authorization.UserRole.changeset/2","doc":"Changeset para crear o actualizar una asignación de rol a usuario.","ref":"AuthManager.Authorization.UserRole.html#changeset/2"},{"type":"module","title":"AuthManager.Core.Config","doc":"Módulo para gestionar la configuración de AuthManager.","ref":"AuthManager.Core.Config.html"},{"type":"function","title":"AuthManager.Core.Config.configure_endpoint/1","doc":"Configura el endpoint Phoenix para la aplicación en tiempo de ejecución.","ref":"AuthManager.Core.Config.html#configure_endpoint/1"},{"type":"function","title":"AuthManager.Core.Config.configure_error_views/2","doc":"Configura los módulos de vistas y plantillas para errores de autenticación/autorización.","ref":"AuthManager.Core.Config.html#configure_error_views/2"},{"type":"function","title":"AuthManager.Core.Config.configure_repo/1","doc":"Configura el repositorio para la aplicación en tiempo de ejecución.\nÚtil para pruebas o configuración dinámica.","ref":"AuthManager.Core.Config.html#configure_repo/1"},{"type":"function","title":"AuthManager.Core.Config.configure_session_handler/1","doc":"Configura el manejador de sesión.","ref":"AuthManager.Core.Config.html#configure_session_handler/1"},{"type":"function","title":"AuthManager.Core.Config.endpoint/0","doc":"Obtiene el endpoint configurado para la aplicación.","ref":"AuthManager.Core.Config.html#endpoint/0"},{"type":"function","title":"AuthManager.Core.Config.error_template/0","doc":"Obtiene la plantilla de error configurada.","ref":"AuthManager.Core.Config.html#error_template/0"},{"type":"function","title":"AuthManager.Core.Config.error_view/0","doc":"Obtiene la vista de error configurada.","ref":"AuthManager.Core.Config.html#error_view/0"},{"type":"function","title":"AuthManager.Core.Config.get/2","doc":"Obtiene una configuración específica.","ref":"AuthManager.Core.Config.html#get/2"},{"type":"function","title":"AuthManager.Core.Config.repo/0","doc":"Obtiene el repositorio configurado para la aplicación.","ref":"AuthManager.Core.Config.html#repo/0"},{"type":"function","title":"AuthManager.Core.Config.session_handler/0","doc":"Obtiene el manejador de sesión configurado.","ref":"AuthManager.Core.Config.html#session_handler/0"},{"type":"module","title":"AuthManager.Core.Controller","doc":"Controlador principal que proporciona funciones para gestionar usuarios, roles y permisos.","ref":"AuthManager.Core.Controller.html"},{"type":"function","title":"AuthManager.Core.Controller.assign_parent_permission/2","doc":"Asigna un permiso padre a un permiso hijo.","ref":"AuthManager.Core.Controller.html#assign_parent_permission/2"},{"type":"function","title":"AuthManager.Core.Controller.assign_parent_role/3","doc":"Asigna un rol padre a un rol hijo.","ref":"AuthManager.Core.Controller.html#assign_parent_role/3"},{"type":"function","title":"AuthManager.Core.Controller.assign_permission_to_role/3","doc":"Asigna un permiso a un rol.","ref":"AuthManager.Core.Controller.html#assign_permission_to_role/3"},{"type":"function","title":"AuthManager.Core.Controller.assign_permission_to_user/3","doc":"Asigna un permiso a un usuario.","ref":"AuthManager.Core.Controller.html#assign_permission_to_user/3"},{"type":"function","title":"AuthManager.Core.Controller.assign_role_to_user/3","doc":"Asigna un rol a un usuario.","ref":"AuthManager.Core.Controller.html#assign_role_to_user/3"},{"type":"function","title":"AuthManager.Core.Controller.can?/2","doc":"Verifica si un usuario tiene un permiso específico.\nConsidera permisos directos, heredados a través de roles y padres de permisos.","ref":"AuthManager.Core.Controller.html#can?/2"},{"type":"function","title":"AuthManager.Core.Controller.can_by?/1","doc":"Función unificada para verificar permisos o roles.\n\nOpciones admitidas:\n- user: El usuario a verificar\n- permission: El permiso a verificar\n- role: El rol a verificar\n\nEjemplos:\n```\ncan_by?(user: user, permission: \"delete_users\")\ncan_by?(user: user, role: \"admin\")\ncan_by?(role: \"editor\", permission: \"edit_articles\")\n```","ref":"AuthManager.Core.Controller.html#can_by?/1"},{"type":"function","title":"AuthManager.Core.Controller.create_permission/1","doc":"Crea un nuevo permiso.","ref":"AuthManager.Core.Controller.html#create_permission/1"},{"type":"function","title":"AuthManager.Core.Controller.create_role/1","doc":"Crea un nuevo rol.","ref":"AuthManager.Core.Controller.html#create_role/1"},{"type":"function","title":"AuthManager.Core.Controller.create_user/1","doc":"Crea un nuevo usuario.","ref":"AuthManager.Core.Controller.html#create_user/1"},{"type":"function","title":"AuthManager.Core.Controller.get_all_permissions/0","doc":"Obtiene todos los permisos.","ref":"AuthManager.Core.Controller.html#get_all_permissions/0"},{"type":"function","title":"AuthManager.Core.Controller.get_all_roles/0","doc":"Obtiene todos los roles.","ref":"AuthManager.Core.Controller.html#get_all_roles/0"},{"type":"function","title":"AuthManager.Core.Controller.get_all_users/0","doc":"Obtiene todos los usuarios.","ref":"AuthManager.Core.Controller.html#get_all_users/0"},{"type":"function","title":"AuthManager.Core.Controller.get_role_permissions/1","doc":"Obtiene todos los permisos de un rol.\nIncluye permisos directos y a través de roles padre.","ref":"AuthManager.Core.Controller.html#get_role_permissions/1"},{"type":"function","title":"AuthManager.Core.Controller.get_user_permissions/1","doc":"Obtiene todos los permisos de un usuario.\nIncluye permisos directos y a través de roles.","ref":"AuthManager.Core.Controller.html#get_user_permissions/1"},{"type":"function","title":"AuthManager.Core.Controller.get_user_roles/1","doc":"Obtiene todos los roles de un usuario.","ref":"AuthManager.Core.Controller.html#get_user_roles/1"},{"type":"function","title":"AuthManager.Core.Controller.has_role?/2","doc":"Verifica si un usuario tiene un rol específico.\nConsidera roles directos y heredados a través de roles padres.","ref":"AuthManager.Core.Controller.html#has_role?/2"},{"type":"function","title":"AuthManager.Core.Controller.repo/0","doc":"Obtiene el repositorio configurado para la aplicación.","ref":"AuthManager.Core.Controller.html#repo/0"},{"type":"function","title":"AuthManager.Core.Controller.role_has_permission?/2","doc":"Verifica si un rol tiene un permiso específico.\nConsidera permisos directos y heredados a través de roles padres.","ref":"AuthManager.Core.Controller.html#role_has_permission?/2"},{"type":"module","title":"AuthManager.Core.Middleware","doc":"Proporciona middlewares para Phoenix para verificar permisos y roles.","ref":"AuthManager.Core.Middleware.html"},{"type":"function","title":"AuthManager.Core.Middleware.authorize/1","doc":"Crea un plug que verifica una condición personalizada utilizando can_by?.","ref":"AuthManager.Core.Middleware.html#authorize/1"},{"type":"function","title":"Ejemplos - AuthManager.Core.Middleware.authorize/1","doc":"```elixir\n# Verificar si un usuario tiene un permiso\npipe_through [:browser, AuthManager.Core.Middleware.authorize(permission: \"admin:read\")]\n\n# Verificar si un usuario tiene un rol\npipe_through [:browser, AuthManager.Core.Middleware.authorize(role: \"admin\")]\n\n# Verificar si un rol tiene un permiso (usando el rol del usuario actual)\npipe_through [:browser, AuthManager.Core.Middleware.authorize(permission: \"admin:read\", use_current_user_role: true)]\n```","ref":"AuthManager.Core.Middleware.html#authorize/1-ejemplos"},{"type":"function","title":"AuthManager.Core.Middleware.require_permission/1","doc":"Crea un plug que verifica si un usuario tiene un permiso específico.","ref":"AuthManager.Core.Middleware.html#require_permission/1"},{"type":"function","title":"Opciones - AuthManager.Core.Middleware.require_permission/1","doc":"* `:permission` - El permiso requerido (obligatorio)\n* `:assign_key` - La clave para almacenar el resultado en conn.assigns (por defecto: :authorized)\n* `:handler` - Función para manejar usuarios no autorizados\n* `:error_message` - Mensaje de error para usuarios no autorizados\n* `:error_view` - Vista de error para usuarios no autorizados\n* `:error_template` - Plantilla de error para usuarios no autorizados","ref":"AuthManager.Core.Middleware.html#require_permission/1-opciones"},{"type":"function","title":"AuthManager.Core.Middleware.require_role/1","doc":"Crea un plug que verifica si un usuario tiene un rol específico.","ref":"AuthManager.Core.Middleware.html#require_role/1"},{"type":"function","title":"Opciones - AuthManager.Core.Middleware.require_role/1","doc":"* `:role` - El rol requerido (obligatorio)\n* `:assign_key` - La clave para almacenar el resultado en conn.assigns (por defecto: :authorized)\n* `:handler` - Función para manejar usuarios no autorizados\n* `:error_message` - Mensaje de error para usuarios no autorizados\n* `:error_view` - Vista de error para usuarios no autorizados\n* `:error_template` - Plantilla de error para usuarios no autorizados","ref":"AuthManager.Core.Middleware.html#require_role/1-opciones"},{"type":"module","title":"AuthManager.Core.Seeds","doc":"Funciones para sembrar la base de datos con datos iniciales.","ref":"AuthManager.Core.Seeds.html"},{"type":"function","title":"AuthManager.Core.Seeds.create_basic_seeds/0","doc":"Crea los roles y permisos básicos del sistema.\n\nRoles:\n- admin: Administrador del sistema con todos los permisos\n- manager: Gerente con permisos de gestión\n- user: Usuario básico\n\nPermisos (por categoría):\n- users: Gestión de usuarios\n- roles: Gestión de roles\n- permissions: Gestión de permisos\n- system: Configuración del sistema","ref":"AuthManager.Core.Seeds.html#create_basic_seeds/0"},{"type":"function","title":"AuthManager.Core.Seeds.ensure_seeds_exist/0","doc":"Crea las semillas solo si no existen ya.\nDevuelve :ok si las semillas ya existían o fueron creadas con éxito.","ref":"AuthManager.Core.Seeds.html#ensure_seeds_exist/0"},{"type":"function","title":"AuthManager.Core.Seeds.seeds_exist?/0","doc":"Comprueba si las semillas ya han sido creadas,\npara evitar crear duplicados.","ref":"AuthManager.Core.Seeds.html#seeds_exist?/0"},{"type":"module","title":"AuthManager.Phoenix","doc":"Funciones para integrar AuthManager con Phoenix.\n\nFunción para utilizar en un controller de Phoenix para requerir autenticación.","ref":"AuthManager.Phoenix.html"},{"type":"module","title":"Ejemplo - AuthManager.Phoenix","doc":"```elixir\ndefmodule MyAppWeb.UserController do\n  use MyAppWeb, :controller\n  use AuthManager.Phoenix, :controller\n\n  plug :require_authenticated_user when action in [:index, :show]\n\n  def index(conn, _params) do\n    # Solo usuarios autenticados pueden acceder aquí\n    render(conn, \"index.html\")\n  end\nend\n```","ref":"AuthManager.Phoenix.html#module-ejemplo"},{"type":"macro","title":"AuthManager.Phoenix.__using__/1","doc":"Función para utilizar en un view de Phoenix para añadir helpers de autenticación.","ref":"AuthManager.Phoenix.html#__using__/1"},{"type":"macro","title":"Ejemplo - AuthManager.Phoenix.__using__/1","doc":"```elixir\ndefmodule MyAppWeb.LayoutView do\n  use MyAppWeb, :view\n  use AuthManager.Phoenix, :view\n\n  # Ahora puede usar funciones como `logged_in?` y `current_user` en sus templates\nend\n```","ref":"AuthManager.Phoenix.html#__using__/1-ejemplo"},{"type":"module","title":"AuthManager.Tools.CryptoTools","doc":"Utilidades para operaciones criptográficas.","ref":"AuthManager.Tools.CryptoTools.html"},{"type":"function","title":"AuthManager.Tools.CryptoTools.decode_and_decrypt/3","doc":"Decodifica y descifra datos que fueron cifrados y codificados con encrypt_and_encode/3.","ref":"AuthManager.Tools.CryptoTools.html#decode_and_decrypt/3"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.decode_and_decrypt/3","doc":"iex> CryptoTools.decode_and_decrypt(encrypted, key)\n    \"datos secretos\"","ref":"AuthManager.Tools.CryptoTools.html#decode_and_decrypt/3-ejemplos"},{"type":"function","title":"AuthManager.Tools.CryptoTools.decrypt/5","doc":"Descifra datos cifrados con AES en modo GCM.","ref":"AuthManager.Tools.CryptoTools.html#decrypt/5"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.decrypt/5","doc":"iex> CryptoTools.decrypt(encrypted, iv, tag, key)\n    \"datos secretos\"","ref":"AuthManager.Tools.CryptoTools.html#decrypt/5-ejemplos"},{"type":"function","title":"AuthManager.Tools.CryptoTools.derive_key/4","doc":"Deriva una clave a partir de una contraseña utilizando PBKDF2.","ref":"AuthManager.Tools.CryptoTools.html#derive_key/4"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.derive_key/4","doc":"iex> salt = :crypto.strong_rand_bytes(16)\n    iex> CryptoTools.derive_key(\"mypassword\", salt, 10000, 32)\n    <<...>>","ref":"AuthManager.Tools.CryptoTools.html#derive_key/4-ejemplos"},{"type":"function","title":"AuthManager.Tools.CryptoTools.encrypt/3","doc":"Cifra un string utilizando AES en modo GCM.","ref":"AuthManager.Tools.CryptoTools.html#encrypt/3"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.encrypt/3","doc":"iex> key = :crypto.strong_rand_bytes(32)\n    iex> {encrypted, iv, tag} = CryptoTools.encrypt(\"datos secretos\", key)","ref":"AuthManager.Tools.CryptoTools.html#encrypt/3-ejemplos"},{"type":"function","title":"AuthManager.Tools.CryptoTools.encrypt_and_encode/3","doc":"Cifra un string y lo codifica en base64 para almacenamiento o transmisión.","ref":"AuthManager.Tools.CryptoTools.html#encrypt_and_encode/3"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.encrypt_and_encode/3","doc":"iex> key = :crypto.strong_rand_bytes(32)\n    iex> encrypted = CryptoTools.encrypt_and_encode(\"datos secretos\", key)","ref":"AuthManager.Tools.CryptoTools.html#encrypt_and_encode/3-ejemplos"},{"type":"function","title":"AuthManager.Tools.CryptoTools.generate_token/1","doc":"Genera un token aleatorio de una longitud específica.","ref":"AuthManager.Tools.CryptoTools.html#generate_token/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.generate_token/1","doc":"iex> CryptoTools.generate_token(16)\n    \"f3d8e1c5a9b7...\"","ref":"AuthManager.Tools.CryptoTools.html#generate_token/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.CryptoTools.hash_password/1","doc":"Genera un hash seguro de una contraseña utilizando bcrypt.","ref":"AuthManager.Tools.CryptoTools.html#hash_password/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.hash_password/1","doc":"iex> CryptoTools.hash_password(\"secretpassword\")\n    \"$2b$12$...\"","ref":"AuthManager.Tools.CryptoTools.html#hash_password/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.CryptoTools.hmac/2","doc":"Genera un hash HMAC utilizando SHA-256.","ref":"AuthManager.Tools.CryptoTools.html#hmac/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.hmac/2","doc":"iex> CryptoTools.hmac(\"datos\", \"secreto\")\n    \"...\"","ref":"AuthManager.Tools.CryptoTools.html#hmac/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.CryptoTools.md5/1","doc":"Genera un hash MD5 de los datos proporcionados.\nNota: MD5 no debe usarse para seguridad, solo para checksums o identificadores no sensibles.","ref":"AuthManager.Tools.CryptoTools.html#md5/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.md5/1","doc":"iex> CryptoTools.md5(\"hello world\")\n    \"5eb63bbbe01eeed093cb22bb8f5acdc3\"","ref":"AuthManager.Tools.CryptoTools.html#md5/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.CryptoTools.sha256/1","doc":"Genera un hash SHA-256 de los datos proporcionados.","ref":"AuthManager.Tools.CryptoTools.html#sha256/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.sha256/1","doc":"iex> CryptoTools.sha256(\"hello world\")\n    \"b94d27b9934d3e08a52e52d7da7dabfac484efe37a5380ee9088f7ace2efcde9\"","ref":"AuthManager.Tools.CryptoTools.html#sha256/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.CryptoTools.verify_password/2","doc":"Verifica si una contraseña coincide con un hash.","ref":"AuthManager.Tools.CryptoTools.html#verify_password/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.CryptoTools.verify_password/2","doc":"iex> CryptoTools.verify_password(\"secretpassword\", \"$2b$12$...\")\n    true","ref":"AuthManager.Tools.CryptoTools.html#verify_password/2-ejemplos"},{"type":"module","title":"AuthManager.Tools.DateTools","doc":"Utilidades para manipulación de fechas y tiempos.","ref":"AuthManager.Tools.DateTools.html"},{"type":"function","title":"AuthManager.Tools.DateTools.add/2","doc":"Añade un número específico de días, meses o años a una fecha.","ref":"AuthManager.Tools.DateTools.html#add/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.DateTools.add/2","doc":"iex> DateTools.add(~D[2023-05-15], days: 5)\n    ~D[2023-05-20]\n\n    iex> DateTools.add(~D[2023-05-15], months: 2)\n    ~D[2023-07-15]\n\n    iex> DateTools.add(~D[2023-05-15], years: 1)\n    ~D[2024-05-15]","ref":"AuthManager.Tools.DateTools.html#add/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.DateTools.age_from_birthdate/1","doc":"Calcula la edad en años a partir de una fecha de nacimiento.","ref":"AuthManager.Tools.DateTools.html#age_from_birthdate/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.DateTools.age_from_birthdate/1","doc":"iex> DateTools.age_from_birthdate(~D[1990-05-15])\n    # Retorna la edad actual, basada en la fecha actual","ref":"AuthManager.Tools.DateTools.html#age_from_birthdate/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.DateTools.between?/3","doc":"Determina si una fecha está entre dos fechas.","ref":"AuthManager.Tools.DateTools.html#between?/3"},{"type":"function","title":"Ejemplos - AuthManager.Tools.DateTools.between?/3","doc":"iex> DateTools.between?(~D[2023-05-15], ~D[2023-05-10], ~D[2023-05-20])\n    true","ref":"AuthManager.Tools.DateTools.html#between?/3-ejemplos"},{"type":"function","title":"AuthManager.Tools.DateTools.date_range/2","doc":"Obtiene una lista de fechas en un rango.","ref":"AuthManager.Tools.DateTools.html#date_range/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.DateTools.date_range/2","doc":"iex> DateTools.date_range(~D[2023-05-15], ~D[2023-05-20])\n    [~D[2023-05-15], ~D[2023-05-16], ~D[2023-05-17], ~D[2023-05-18], ~D[2023-05-19], ~D[2023-05-20]]","ref":"AuthManager.Tools.DateTools.html#date_range/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.DateTools.days_between/2","doc":"Calcula la diferencia en días entre dos fechas.","ref":"AuthManager.Tools.DateTools.html#days_between/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.DateTools.days_between/2","doc":"iex> DateTools.days_between(~D[2023-05-15], ~D[2023-05-20])\n    5","ref":"AuthManager.Tools.DateTools.html#days_between/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.DateTools.end_of/2","doc":"Devuelve el fin del período (día, semana, mes, trimestre, año) para una fecha dada.","ref":"AuthManager.Tools.DateTools.html#end_of/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.DateTools.end_of/2","doc":"iex> DateTools.end_of(:month, ~D[2023-05-15])\n    ~D[2023-05-31]\n\n    iex> DateTools.end_of(:year, ~D[2023-05-15])\n    ~D[2023-12-31]","ref":"AuthManager.Tools.DateTools.html#end_of/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.DateTools.format/2","doc":"Convierte una fecha a una cadena formateada.","ref":"AuthManager.Tools.DateTools.html#format/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.DateTools.format/2","doc":"iex> DateTools.format(~D[2023-05-15], \"{YYYY}-{0M}-{0D}\")\n    \"2023-05-15\"\n\n    iex> DateTools.format(~D[2023-05-15], \"{D} de {Mfull} de {YYYY}\")\n    \"15 de mayo de 2023\"","ref":"AuthManager.Tools.DateTools.html#format/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.DateTools.start_of/2","doc":"Devuelve el inicio del período (día, semana, mes, trimestre, año) para una fecha dada.","ref":"AuthManager.Tools.DateTools.html#start_of/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.DateTools.start_of/2","doc":"iex> DateTools.start_of(:month, ~D[2023-05-15])\n    ~D[2023-05-01]\n\n    iex> DateTools.start_of(:year, ~D[2023-05-15])\n    ~D[2023-01-01]","ref":"AuthManager.Tools.DateTools.html#start_of/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.DateTools.to_iso8601/1","doc":"Convierte una fecha a formato ISO 8601.","ref":"AuthManager.Tools.DateTools.html#to_iso8601/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.DateTools.to_iso8601/1","doc":"iex> DateTools.to_iso8601(~D[2023-05-15])\n    \"2023-05-15\"\n\n    iex> DateTools.to_iso8601(~N[2023-05-15 10:30:45])\n    \"2023-05-15T10:30:45\"","ref":"AuthManager.Tools.DateTools.html#to_iso8601/1-ejemplos"},{"type":"module","title":"AuthManager.Tools.ListTools","doc":"Utilidades para manipulación de listas.","ref":"AuthManager.Tools.ListTools.html"},{"type":"function","title":"AuthManager.Tools.ListTools.chunk/2","doc":"Divide una lista en sublistas de un tamaño específico.","ref":"AuthManager.Tools.ListTools.html#chunk/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.chunk/2","doc":"iex> ListTools.chunk([1, 2, 3, 4, 5, 6, 7], 3)\n    [[1, 2, 3], [4, 5, 6], [7]]","ref":"AuthManager.Tools.ListTools.html#chunk/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.ListTools.combinations/2","doc":"Encuentra todas las combinaciones de una lista, tomando n elementos.","ref":"AuthManager.Tools.ListTools.html#combinations/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.combinations/2","doc":"iex> ListTools.combinations([1, 2, 3], 2)\n    [[1, 2], [1, 3], [2, 3]]","ref":"AuthManager.Tools.ListTools.html#combinations/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.ListTools.compress/1","doc":"Comprime elementos adyacentes duplicados en la lista.","ref":"AuthManager.Tools.ListTools.html#compress/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.compress/1","doc":"iex> ListTools.compress([1, 1, 2, 3, 3, 3, 4, 4, 1])\n    [1, 2, 3, 4, 1]","ref":"AuthManager.Tools.ListTools.html#compress/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.ListTools.flatten/1","doc":"Aplana una lista anidada en una única lista.","ref":"AuthManager.Tools.ListTools.html#flatten/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.flatten/1","doc":"iex> ListTools.flatten([1, [2, 3], [4, [5, 6]]])\n    [1, 2, 3, 4, 5, 6]","ref":"AuthManager.Tools.ListTools.html#flatten/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.ListTools.group_by/2","doc":"Agrupa los elementos de una lista por el resultado de una función.","ref":"AuthManager.Tools.ListTools.html#group_by/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.group_by/2","doc":"iex> ListTools.group_by([%{name: \"Juan\", age: 30}, %{name: \"María\", age: 30}, %{name: \"Pedro\", age: 25}], fn x -> x.age end)\n    %{30 => [%{name: \"Juan\", age: 30}, %{name: \"María\", age: 30}], 25 => [%{name: \"Pedro\", age: 25}]}","ref":"AuthManager.Tools.ListTools.html#group_by/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.ListTools.interleave/1","doc":"Intercala dos o más listas, alternando elementos.","ref":"AuthManager.Tools.ListTools.html#interleave/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.interleave/1","doc":"iex> ListTools.interleave([1, 2, 3], [4, 5, 6])\n    [1, 4, 2, 5, 3, 6]\n\n    iex> ListTools.interleave([1, 2], [3], [4, 5, 6])\n    [1, 3, 4, 2, 5, 6]","ref":"AuthManager.Tools.ListTools.html#interleave/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.ListTools.interleave/4","doc":"","ref":"AuthManager.Tools.ListTools.html#interleave/4"},{"type":"function","title":"AuthManager.Tools.ListTools.intersperse/2","doc":"Intercala un elemento entre cada elemento de una lista.","ref":"AuthManager.Tools.ListTools.html#intersperse/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.intersperse/2","doc":"iex> ListTools.intersperse([1, 2, 3], :sep)\n    [1, :sep, 2, :sep, 3]","ref":"AuthManager.Tools.ListTools.html#intersperse/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.ListTools.permutations/1","doc":"Encuentra todas las permutaciones de una lista.","ref":"AuthManager.Tools.ListTools.html#permutations/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.permutations/1","doc":"iex> ListTools.permutations([1, 2, 3])\n    [[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]]","ref":"AuthManager.Tools.ListTools.html#permutations/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.ListTools.rotate/2","doc":"Rota una lista por un cierto número de posiciones.\nSi el número es positivo, rota a la izquierda.\nSi el número es negativo, rota a la derecha.","ref":"AuthManager.Tools.ListTools.html#rotate/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.rotate/2","doc":"iex> ListTools.rotate([1, 2, 3, 4, 5], 2)\n    [3, 4, 5, 1, 2]\n\n    iex> ListTools.rotate([1, 2, 3, 4, 5], -1)\n    [5, 1, 2, 3, 4]","ref":"AuthManager.Tools.ListTools.html#rotate/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.ListTools.sliding_window/2","doc":"Agrupa elementos consecutivos en sublistas según el tamaño especificado.\nA diferencia de chunk, esto crea \"ventanas deslizantes\".","ref":"AuthManager.Tools.ListTools.html#sliding_window/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.sliding_window/2","doc":"iex> ListTools.sliding_window([1, 2, 3, 4, 5], 3)\n    [[1, 2, 3], [2, 3, 4], [3, 4, 5]]","ref":"AuthManager.Tools.ListTools.html#sliding_window/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.ListTools.unique/1","doc":"Elimina duplicados de una lista, manteniendo el orden.","ref":"AuthManager.Tools.ListTools.html#unique/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.ListTools.unique/1","doc":"iex> ListTools.unique([1, 2, 3, 2, 1, 4])\n    [1, 2, 3, 4]","ref":"AuthManager.Tools.ListTools.html#unique/1-ejemplos"},{"type":"module","title":"AuthManager.Tools.MapTools","doc":"Utilidades para manipulación de mapas.","ref":"AuthManager.Tools.MapTools.html"},{"type":"function","title":"AuthManager.Tools.MapTools.deep_filter/2","doc":"Filtra un mapa recursivamente, manteniendo solo las entradas que cumplen\ncon la función de predicado.","ref":"AuthManager.Tools.MapTools.html#deep_filter/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.MapTools.deep_filter/2","doc":"iex> MapTools.deep_filter(%{a: 1, b: %{c: 2, d: nil}}, fn {_k, v} -> not is_nil(v) end)\n    %{a: 1, b: %{c: 2}}","ref":"AuthManager.Tools.MapTools.html#deep_filter/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.MapTools.deep_map/2","doc":"Transforma los valores de un mapa recursivamente utilizando una función.","ref":"AuthManager.Tools.MapTools.html#deep_map/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.MapTools.deep_map/2","doc":"iex> MapTools.deep_map(%{a: 1, b: %{c: 2}}, fn v -> v * 2 end)\n    %{a: 2, b: %{c: 4}}","ref":"AuthManager.Tools.MapTools.html#deep_map/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.MapTools.deep_merge/2","doc":"Fusiona dos mapas profundamente, combinando mapas anidados.","ref":"AuthManager.Tools.MapTools.html#deep_merge/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.MapTools.deep_merge/2","doc":"iex> MapTools.deep_merge(%{a: 1, b: %{c: 2}}, %{b: %{d: 3}, e: 4})\n    %{a: 1, b: %{c: 2, d: 3}, e: 4}","ref":"AuthManager.Tools.MapTools.html#deep_merge/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.MapTools.flatten/2","doc":"Aplana un mapa anidado en un mapa plano con claves compuestas.","ref":"AuthManager.Tools.MapTools.html#flatten/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.MapTools.flatten/2","doc":"iex> MapTools.flatten(%{user: %{name: \"Juan\", address: %{city: \"Madrid\"}}})\n    %{\"user.name\" => \"Juan\", \"user.address.city\" => \"Madrid\"}","ref":"AuthManager.Tools.MapTools.html#flatten/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.MapTools.get_in_path/2","doc":"Obtiene un valor de un mapa anidado utilizando una lista de claves o una ruta separada por puntos.","ref":"AuthManager.Tools.MapTools.html#get_in_path/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.MapTools.get_in_path/2","doc":"iex> MapTools.get_in_path(%{user: %{name: \"Juan\"}}, [:user, :name])\n    \"Juan\"\n\n    iex> MapTools.get_in_path(%{user: %{name: \"Juan\"}}, \"user.name\")\n    \"Juan\"","ref":"AuthManager.Tools.MapTools.html#get_in_path/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.MapTools.keys_to_atoms/1","doc":"Convierte claves de string a átomos en un mapa, recursivamente.","ref":"AuthManager.Tools.MapTools.html#keys_to_atoms/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.MapTools.keys_to_atoms/1","doc":"iex> MapTools.keys_to_atoms(%{\"name\" => \"Juan\", \"age\" => 30})\n    %{name: \"Juan\", age: 30}\n\n    iex> MapTools.keys_to_atoms(%{\"user\" => %{\"name\" => \"Juan\", \"age\" => 30}})\n    %{user: %{name: \"Juan\", age: 30}}","ref":"AuthManager.Tools.MapTools.html#keys_to_atoms/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.MapTools.keys_to_strings/1","doc":"Convierte claves de átomos a strings en un mapa, recursivamente.","ref":"AuthManager.Tools.MapTools.html#keys_to_strings/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.MapTools.keys_to_strings/1","doc":"iex> MapTools.keys_to_strings(%{name: \"Juan\", age: 30})\n    %{\"name\" => \"Juan\", \"age\" => 30}\n\n    iex> MapTools.keys_to_strings(%{user: %{name: \"Juan\", age: 30}})\n    %{\"user\" => %{\"name\" => \"Juan\", \"age\" => 30}}","ref":"AuthManager.Tools.MapTools.html#keys_to_strings/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.MapTools.unflatten/1","doc":"Desaplana un mapa plano con claves compuestas en un mapa anidado.","ref":"AuthManager.Tools.MapTools.html#unflatten/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.MapTools.unflatten/1","doc":"iex> MapTools.unflatten(%{\"user.name\" => \"Juan\", \"user.address.city\" => \"Madrid\"})\n    %{\"user\" => %{\"name\" => \"Juan\", \"address\" => %{\"city\" => \"Madrid\"}}}","ref":"AuthManager.Tools.MapTools.html#unflatten/1-ejemplos"},{"type":"module","title":"AuthManager.Tools.StringTools","doc":"Utilidades para manipulación de strings.","ref":"AuthManager.Tools.StringTools.html"},{"type":"function","title":"AuthManager.Tools.StringTools.alphanumeric_only/1","doc":"Elimina caracteres no alfanuméricos de un string.","ref":"AuthManager.Tools.StringTools.html#alphanumeric_only/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.alphanumeric_only/1","doc":"iex> StringTools.alphanumeric_only(\"Hello, World! 123\")\n    \"HelloWorld123\"","ref":"AuthManager.Tools.StringTools.html#alphanumeric_only/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.StringTools.capitalize_words/1","doc":"Capitaliza la primera letra de cada palabra en un string.","ref":"AuthManager.Tools.StringTools.html#capitalize_words/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.capitalize_words/1","doc":"iex> StringTools.capitalize_words(\"hello world\")\n    \"Hello World\"\n\n    iex> StringTools.capitalize_words(\"HELLO WORLD\")\n    \"Hello World\"\n\n    iex> StringTools.capitalize_words(\"hello_world\")\n    \"Hello_world\"","ref":"AuthManager.Tools.StringTools.html#capitalize_words/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.StringTools.format_with_pattern/2","doc":"Formatea un string según un patrón con marcadores de posición.","ref":"AuthManager.Tools.StringTools.html#format_with_pattern/2"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.format_with_pattern/2","doc":"iex> StringTools.format_with_pattern(\"4111111111111111\", \"XXXX-XXXX-XXXX-XXXX\")\n    \"4111-1111-1111-1111\"\n\n    iex> StringTools.format_with_pattern(\"123456789\", \"(XXX) XXX-XXX\")\n    \"(123) 456-789\"","ref":"AuthManager.Tools.StringTools.html#format_with_pattern/2-ejemplos"},{"type":"function","title":"AuthManager.Tools.StringTools.from_bytecode/1","doc":"Convierte bytecode (lista de bytes) a string.","ref":"AuthManager.Tools.StringTools.html#from_bytecode/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.from_bytecode/1","doc":"iex> StringTools.from_bytecode([65, 66, 67])\n    \"ABC\"","ref":"AuthManager.Tools.StringTools.html#from_bytecode/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.StringTools.slugify/1","doc":"Genera un slug a partir de un string.","ref":"AuthManager.Tools.StringTools.html#slugify/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.slugify/1","doc":"iex> StringTools.slugify(\"Hello World\")\n    \"hello-world\"\n\n    iex> StringTools.slugify(\"¡Hola, Mundo!\")\n    \"hola-mundo\"\n\n    iex> StringTools.slugify(\"  Hello  World  \")\n    \"hello-world\"","ref":"AuthManager.Tools.StringTools.html#slugify/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.StringTools.to_bytecode/1","doc":"Convierte un string a bytecode (lista de bytes).","ref":"AuthManager.Tools.StringTools.html#to_bytecode/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.to_bytecode/1","doc":"iex> StringTools.to_bytecode(\"ABC\")\n    [65, 66, 67]","ref":"AuthManager.Tools.StringTools.html#to_bytecode/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.StringTools.to_camel_case/1","doc":"Convierte un string a camelCase.","ref":"AuthManager.Tools.StringTools.html#to_camel_case/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.to_camel_case/1","doc":"iex> StringTools.to_camel_case(\"hello world\")\n    \"helloWorld\"\n\n    iex> StringTools.to_camel_case(\"hello_world\")\n    \"helloWorld\"\n\n    iex> StringTools.to_camel_case(\"HelloWorld\")\n    \"helloWorld\"","ref":"AuthManager.Tools.StringTools.html#to_camel_case/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.StringTools.to_kebab_case/1","doc":"Convierte un string a kebab-case.","ref":"AuthManager.Tools.StringTools.html#to_kebab_case/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.to_kebab_case/1","doc":"iex> StringTools.to_kebab_case(\"Hello World\")\n    \"hello-world\"\n\n    iex> StringTools.to_kebab_case(\"HelloWorld\")\n    \"hello-world\"\n\n    iex> StringTools.to_kebab_case(\"hello_world\")\n    \"hello-world\"","ref":"AuthManager.Tools.StringTools.html#to_kebab_case/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.StringTools.to_pascal_case/1","doc":"Convierte un string a PascalCase.","ref":"AuthManager.Tools.StringTools.html#to_pascal_case/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.to_pascal_case/1","doc":"iex> StringTools.to_pascal_case(\"hello world\")\n    \"HelloWorld\"\n\n    iex> StringTools.to_pascal_case(\"hello_world\")\n    \"HelloWorld\"\n\n    iex> StringTools.to_pascal_case(\"helloWorld\")\n    \"HelloWorld\"","ref":"AuthManager.Tools.StringTools.html#to_pascal_case/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.StringTools.to_snake_case/1","doc":"Convierte un string a snake_case.","ref":"AuthManager.Tools.StringTools.html#to_snake_case/1"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.to_snake_case/1","doc":"iex> StringTools.to_snake_case(\"Hello World\")\n    \"hello_world\"\n\n    iex> StringTools.to_snake_case(\"HelloWorld\")\n    \"hello_world\"\n\n    iex> StringTools.to_snake_case(\"helloWorld\")\n    \"hello_world\"","ref":"AuthManager.Tools.StringTools.html#to_snake_case/1-ejemplos"},{"type":"function","title":"AuthManager.Tools.StringTools.truncate/3","doc":"Trunca un string a una longitud máxima, añadiendo un sufijo si es necesario.","ref":"AuthManager.Tools.StringTools.html#truncate/3"},{"type":"function","title":"Ejemplos - AuthManager.Tools.StringTools.truncate/3","doc":"iex> StringTools.truncate(\"Hello World\", 5)\n    \"Hello...\"\n\n    iex> StringTools.truncate(\"Hello\", 10)\n    \"Hello\"\n\n    iex> StringTools.truncate(\"Hello World\", 8, \">>\")\n    \"Hello W>>\"","ref":"AuthManager.Tools.StringTools.html#truncate/3-ejemplos"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}